 PROGRAM Testcard(Output);

 Uses Crt,Graph,BGIDriv;

 Var
 GraphDriver, GraphMode, Error : Integer;

PROCEDURE Abort(Msg : string);
Begin
WriteLn (Msg, ':', GraphErrorMsg(GraphResult));
Halt(1);
End;

PROCEDURE OpenGraph;
 Begin
   if RegisterBGIdriver(@EGAVGADriverProc) < 0 then
    Abort('EGA/VGA');
 GraphDriver := Detect;
 InitGraph (Graphdriver,GraphMode,'');
 If GraphResult <> grOk Then
 Begin
WriteLn ('Graphics init error : ', GraphErrorMsg(GraphDriver));
 Halt(1);
 End; {Graphics error Msg}
 End; {OpenGraph}

PROCEDURE Grid;
 { Draws the background grid lines }
Var
Horiz,Vert : Integer;
Begin
  SetColor (15);SetFillStyle (1,7);
  Rectangle (13,5,625,473);FloodFill (15,10,15);
  For Horiz := 49 To 625 Do
  If (Horiz-13) Mod 36 = 0 Then
  Line (Horiz,5,Horiz,473);
  For Vert := 41 To 473 Do
  If (Vert-5) Mod 36 = 0 Then
  Line (13,Vert,625,Vert);
  End; {Grid}

  PROCEDURE ColorStrips;
   { Draws the colour rectangles outside the circle }
  Begin
  SetColor (2);SetFillStyle (1,2);
  Rectangle (50,42,84,238);FloodFill (55,45,2);
  SetColor (12);SetFillStyle (1,12);
  Rectangle (50,239,84,436);FloodFill (55,245,12);
  SetColor (9);SetFillStyle (1,9);
  Rectangle (85,42,120,112);FloodFill (95,45,9);
  SetColor (6);SetFillStyle (1,6);
  Rectangle (85,366,120,436);FloodFill (95,375,6);
  SetColor (9);SetFillStyle (1,9);
  Rectangle (518,42,553,112);FloodFill (525,45,9);
  SetColor (14);SetFillStyle (1,14);
  Rectangle (554,42,588,238);FloodFill (565,45,14);
  SetColor (13);SetFillStyle (1,13);
  Rectangle (554,238,588,436);FloodFill (565,245,13);
  SetColor (6);SetFillStyle (1,6);
  Rectangle (518,366,553,436);FloodFill (525,375,6);
  End; {ColorStrips}

  PROCEDURE BlackCircle;
   { Set up a template to draw the components inside the circle
     and prevent colour spilling }
  Begin
  SetColor (0);
  Circle (319,239,216);
  Line (121,329,517,329);Line (176,401,461,401);
  Line (143,365,495,365);Line (175,149,175,221);
  Line (464,149,464,221);Line (121,149,516,149);
  Line (144,113,494,113);Line (177,77,463,77);
  Line (103,221,535,221);

   { Draw the Yellow and Red parts at the bottom of the circle }
  SetFillStyle (1,14);Floodfill (265,419,0);
  SetColor (12);SetFillStyle (1,12);
  Rectangle (302,402,336,454);FloodFill (305,405,12);

   { Draw top textbox KHALID and bottom textbox ROSSAN
     or your first and last name! }
  SetFillStyle (1,15);
  FloodFill (320,60,0);FloodFill (320,25,0);
  FloodFill (193,383,0);
  SetColor (0);SetFillStyle (1,0);
  Rectangle (247,41,391,77);FloodFill (250,45,0);
  Rectangle (211,365,427,401);FloodFill (215,370,0);
  SetColor (15);SetTextStyle (0, 0, 2);
  OutTextXY(274, 53, 'KHALID');
  OutTextXY(274, 377, 'ROSSAN');

   { Draw pulse and bar - just below the top textbox }
  SetColor (0);
  Line (211,77,211,113);FloodFill (190,90,0);
  Line (427,77,427,113);FloodFill (445,90,0);
  SetFillStyle (1,15);FloodFill (320,90,0);
  SetColor (0);Rectangle (229,77,230,113);

   { Draw the grey scale strips - just above the bottom textbox }
  Line (220,329,220,365);Line (319,329,319,365);
  Line (418,329,418,365);
  SetFillStyle (1,0);FloodFill (190,350,0);
  SetFillStyle (1,8);FloodFill (300,350,0);
  SetFillStyle (1,7);FloodFill (400,350,0);
  SetFillStyle (1,15);FloodFill (420,350,0);

  End; {BlackCircle}

PROCEDURE LowFrequencyBars;
 { Just above the colour bars inside the circle }
Var
VertLine,BlackBar : Integer;
Begin
  SetFillStyle (1,7);FloodFill (320,130,0);
  SetColor (0);
  For VertLine := 144 To 517 Do
  If (VertLine-144) Mod 25 = 0 Then
  Line (VertLine,149,VertLine,113);
  SetFillStyle (1,0);
  For BlackBar := 139 To 517 Do
  If (BlackBar-139) Mod 50 = 0 Then
  FloodFill (BlackBar,131,0);
  End; {LowFrequencyBars}

PROCEDURE Grating;
 { Just above the grey scale strips inside the circle }
Var
i,j,k,l,m : Integer;
Begin
  SetColor (0);SetFillStyle (1,0);
  Line (130,257,130,329);Line (508,257,508,329);
  FloodFill (125,290,0);FloodFill (515,290,0);
  SetFillStyle (1,15);FloodFill (265,293,0);
  { Draw Gratings }
  SetColor (0);SetFillStyle (1,0);
  For i := 134 To 205 Do
  If (i-134) Mod 8 = 0 Then
  Rectangle (i,257,(i+2),329);
  For i := 134 To 205 Do
  If (i-134) Mod 8 = 0 Then
  FloodFill ((i+1),300,0);
  For j := 434 To 506 Do
  If (j-434) Mod 8 = 0 Then
  Rectangle (j,257,(j+2),329);
  For j := 434 To 506 Do
  If (j-434) Mod 8 = 0 Then
  FloodFill ((j+1),300,0);
  For k := 205 To 280 Do
  If (k-205) Mod 6 = 0 Then
  Rectangle (k,257,(k+1),329);
  For l := 355 To 430 Do
  If (l-355) Mod 6 = 0 Then
  Rectangle (l,257,(l+1),329);
  For m := 282 To 353 Do
  If (m-282) Mod 4 = 0 Then
  Line (m,257,m,329);
  End; {Grating}

  PROCEDURE CentreGrid;
   { Draws the cross-like grid lines at the centre of the circle }
  Var
  f : integer;
  Begin
  SetColor (14);SetFillStyle (1,0);
  Rectangle (301,185,337,293);FloodFill (305,190,14);
  SetColor (0);Rectangle (301,185,337,293);
  SetColor (15);
  Line (104,239,534,239);Line (319,185,319,292);
  For f := 121 To 517 Do
  If (f-121) Mod 36 = 0 Then
  Line (f,222,f,256);
  End; {CentreGrid}

  PROCEDURE ColorBars;
   { Draws the colour bars inside the circle }
  Begin
  SetColor (0);Line (247,150,247,220);
  Line (319,150,319,220);Line (391,150,391,220);
  Line (463,150,463,220);
  SetFillStyle (1,11);FloodFill(180,160,0);
  SetFillStyle (1,10);FloodFill(310,160,0);
  SetFillStyle (1,13);FloodFill(380,160,0);
  SetFillStyle (1,12);FloodFill(460,160,0);
  SetColor (10);Line(247,150,247,220);
  SetColor (13);Line(319,150,319,220);
  SetColor (13);Line(391,150,391,220);
  SetFillStyle (1,14);FloodFill(150,150,0);
  SetColor(14);Line (175,150,175,220);
  SetFillStyle (1,1);FloodFill(470,150,0);
  SetColor(1);Line (463,150,463,220);
  End; {ColorBars}

  PROCEDURE WhiteCircle;
   { Final touch-up to the template }
  Begin
  SetColor (15);
  Circle (319,239,216);
  Line (418,329,418,365);Line (177,77,463,77);
  Line (143,365,495,365);Line (176,401,461,401);
  End; {WhiteCircle}

  BEGIN
  OpenGraph;
  Grid;
  ColorStrips;
  BlackCircle;
  ColorBars;
  LowFrequencyBars;
  Grating;
  CentreGrid;
  WhiteCircle;

ReadKey;
 { Allows the Testcard to remain on screen Until a key is pressed }
CloseGraph;
END. {Testcard}



